<ui:composition xmlns:h="http://java.sun.com/jsf/html"
                xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:rich="http://richfaces.org/rich"
                xmlns="http://www.w3.org/1999/xhtml" template="layout/template.xhtml">

    <ui:define name="body">

        <h:outputScript library="js" name="disable_input_spinner_mouse_wheel.js"/>
        <h:form id="newChannel">
            <s:token allowMultiplePosts="true"/>
            <h1>#{messages['net.ihe.gazelle.proxy.ChannelsManagement']}</h1>

            <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                <ui:param name="panel_id" value="search"/>
                <ui:define name="panel_title">
                    <h:outputText value="#{messages['net.ihe.gazelle.proxy.NewChannelConfiguration']}"/>
                </ui:define>
                <div class="row">
                    <div class="col-md-6">
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="messageTypeBox"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.MessageType']}</ui:define>
                            <h:selectOneMenu id="messageTypeBox"
                                             styleClass="form-control gzl-form-control gzl-select-text"
                                             value="#{channelManagerBean.messageType}"
                            >
                                <s:selectItems value="#{channelManagerBean.getMessageTypes()}"
                                               var="cmdField" label="#{cmdField.toString()}"/>
                                <a4j:ajax event="change" render="options"/>
                            </h:selectOneMenu>
                        </s:decorate>
                        <s:decorate id="responderIPDeco" template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="responderIPInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.ResponderIPHostname']}</ui:define>
                            <h:inputText id="responderIPInput" styleClass="form-control"
                                         value="#{channelManagerBean.responderIP}" required="true"
                                         requiredMessage="Responder's IP address is mandatory">
                                <a4j:ajax event="blur" render="responderIPDeco"/>
                            </h:inputText>
                        </s:decorate>
                        <s:decorate id="options" template="/layout/form/_edit.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Options']}</ui:define>
                            <div>
                                <h:selectBooleanCheckbox value="#{channelManagerBean.secureChannel}"
                                                         disabled="#{!(channelManagerBean.isValidTrustStore() and channelManagerBean.isValidKeyStore())}">
                                    <span style="font-size: x-large" title="" class="gzl-icon-lock" />
                                    <span>#{messages['net.ihe.gazelle.proxy.MakeTheChannelSecuredWithTLSConfiguration']} </span>
                                    <a4j:ajax event="change" render="options"/>
                                </h:selectBooleanCheckbox>
                            </div>
                            <s:div id="sniEnabled" rendered="#{channelManagerBean.secureChannel}">
                                <h:selectBooleanCheckbox value="#{channelManagerBean.sniEnabled}">
                                    <span style="font-size: x-large; color: green" class ="gzl-icon-lock"/>
                                    <span>#{messages['net.ihe.gazelle.proxy.EnableServerNameIndicationSNI']} </span>
                                </h:selectBooleanCheckbox>
                            </s:div>
                            <div>
                                <h:selectBooleanCheckbox value="#{channelManagerBean.persistent}">
                                    <span style="font-size: x-large" class ="gzl-icon-save"/>
                                    <span>#{messages['net.ihe.gazelle.proxy.MakeTheChannelPersistent']} </span>
                                </h:selectBooleanCheckbox>
                            </div>
                            <s:div id="httpRewrite" rendered="#{channelManagerBean.isHttpRewriteSupported()}">
                                <h:selectBooleanCheckbox value="#{channelManagerBean.httpRewrite}">
                                    <span style="font-size: x-large" class ="gzl-icon-pencil"/>
                                    <span>#{messages['net.ihe.gazelle.proxy.RewriteHTTPRequest']} </span>
                                </h:selectBooleanCheckbox>
                            </s:div>
                        </s:decorate>
                    </div>
                    <div class="col-md-6">
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="proxyPortSpinnerInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.ProxysPort']}</ui:define>
                            <rich:inputNumberSpinner id="proxyPortSpinnerInput" value="#{channelManagerBean.proxyPort}"
                                                     minValue="#{applicationConfigurationManager.minProxyPort}"
                                                     maxValue="#{applicationConfigurationManager.maxProxyPort}"/>
                        </s:decorate>
                        <s:decorate template="/layout/form/_edit.xhtml">
                            <ui:param name="id" value="responderPortInput"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.RespondersPort']}</ui:define>
                            <rich:inputNumberSpinner id="responderPortInput" value="#{channelManagerBean.responderPort}"
                                                     minValue="1"
                                                     maxValue="65535"
                                                     required="true"
                                                     requiredMessage="Responder's port is mandatory"/>
                        </s:decorate>
                    </div>
                </div>
                <a4j:commandButton
                        value="#{messages['net.ihe.gazelle.proxy.Start']}" styleClass="gzl-btn-green"
                        action="#{channelManagerBean.startChannel()}" render="gazelle-messages,newChannel"/>
            </ui:decorate>
            <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                <ui:param name="panel_id" value="uploadPanel"/>
                <ui:define name="panel_title">
                    <h:outputText value="#{messages['net.ihe.gazelle.proxy.OpenABatchOfChannels']}"/>
                </ui:define>
                <h:outputText
                        value="#{messages['net.ihe.gazelle.proxy.UploadAJSONFileContainingTheListOfChannelsToOpen']}"/>
                <br/>
                <br/>
                <a4j:region id="uploadRegion">
                    <rich:fileUpload
                            fileUploadListener="#{channelManagerBean.channelUploaderConfig}"
                            maxFilesQuantity="1" id="upload" immediateUpload="true"
                            acceptedTypes="json" listHeight="50px" immediate="true">
                        <a4j:ajax event="uploadcomplete" render="@form"/>
                    </rich:fileUpload>
                </a4j:region>
            </ui:decorate>
            <a href="channels.seam">#{messages['net.ihe.gazelle.proxy.ViewOpenedChannels']}</a>

            <s:div rendered="#{channelManagerBean.uploadIsFailed()}">
                <ui:decorate id="failedChannel" template="/layout/panels/_panel_title_id.xhtml">
                    <ui:param name="panel_id" value="failedChannelsMessages"/>
                    <ui:define name="panel_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.FollowingErrorHasOccurred']}"/>
                    </ui:define>
                    <div class="gzl-alert gzl-alert-red">
                        <h:outputText value="#{channelManagerBean.uploadErrorMessage}"/>
                    </div>
                    <s:div rendered="#{not empty channelManagerBean.failedChannels}">
                        <h:outputText value="#{messages['net.ihe.gazelle.proxy.TheFollowingChannelsHaveNotBeenStarted']}"/>
                        <ul>
                            <ui:repeat value="#{channelManagerBean.failedChannels}" var="failedChannel" varStatus="status">
                                <li>
                            <span>
                                #{status.index + 1} - #{messages['net.ihe.gazelle.proxy.ProxyPort_3']} #{failedChannel.proxyPort} - #{messages['net.ihe.gazelle.proxy.Type_2']} #{failedChannel.type}
                                - #{messages['net.ihe.gazelle.proxy.ResponderHost']} #{failedChannel.responder.hostname} - #{messages['net.ihe.gazelle.proxy.ResponderPort_2']} #{failedChannel.responder.port} -
                                <span style="color: red; font-weight: bold">
                                    #{messages['net.ihe.gazelle.proxy.Error_2']} #{failedChannel.unexpectedError.message}
                                </span>
                                <h:panelGroup rendered="#{failedChannel.unexpectedError != null}">
                                    <span>
                                        (<h:commandLink value="#{messages['net.ihe.gazelle.proxy.DownloadFullStacktrace']}"
                                                        action="#{channelManagerBean.downloadFailedChannelStackTrace(failedChannel)}"
                                                        immediate="true" ajaxSingle="true"/>)
                                    </span>
                                </h:panelGroup>
                            </span>
                                </li>
                            </ui:repeat>
                        </ul>
                    </s:div>
                </ui:decorate>
            </s:div>

            <s:div id="successChannel" rendered="#{channelManagerBean.isUploadPerformed() and not channelManagerBean.uploadIsFailed()}">
                <ui:decorate template="/layout/panels/_panel_title_id.xhtml">
                    <ui:param name="panel_id" value="successChannelsMessages"/>
                    <ui:define name="panel_title">
                        <div class="gzl-alert gzl-alert-green">
                            <h:outputText value="#{messages['net.ihe.gazelle.proxy.AllChannelsHasBeenStarted']}"/>
                        </div>
                    </ui:define>
                </ui:decorate>
            </s:div>

            <!--@formatter:off-->
            <script>
                disable_input_spinner_mouse_wheel('#{rich:clientId('proxyPortSpinnerInput')}');
                disable_input_spinner_mouse_wheel('#{rich:clientId('responderPortInput')}');
            </script>
            <!--@formatter:on-->
        </h:form>
    </ui:define>
</ui:composition>
